/*
 *   toglinfo.c
 *                                              T.Teranishi
 */
#ifdef	WIN32
#	include "glos.h"
#endif	/* WIN32 */

#include <GL/gl.h>
#include <GL/glu.h>
#include <stdio.h>
#include <stdlib.h>

#ifdef	WIN32
#	include "GL/glaux.h"
#else	/* WIN32 */
#ifndef	IRIS
#	include "glaux.h"
#else	/* IRIS */
#	include "aux.h"
#endif	/* IRIS */
#	define CALLBACK
#endif	/* WIN32 */

/*
 *   Main Loop
 */
void main(int argc, char** argv)
{
	int		val, dm[2];
	float		fval[2];
	const char *glu_version, *glu_extentions, *glu_renderer;


    auxInitDisplayMode (AUX_SINGLE | AUX_RGB | AUX_DEPTH);
    auxInitPosition (0, 0, 500, 500);
    auxInitWindow (argv[0]);

	fprintf(stdout, "----------------------------------------------------\n");
	fprintf(stdout, "toglinfo : Version 1.02  T.Teranishi\n");
	fprintf(stdout, "----------------------------------------------------\n");
	
	fprintf(stdout, "GL_VERSION:    %s\n", glGetString(GL_VERSION));
	fprintf(stdout, "GL_RENDERER:   %s\n", glGetString(GL_RENDERER));
	fprintf(stdout, "GL_VENDOR:     %s\n", glGetString(GL_VENDOR));
	fprintf(stdout, "GL_EXTENSIONS: %s\n", glGetString(GL_EXTENSIONS));

	fprintf(stdout, "----------------------------------------------------\n");

	glGetIntegerv(GL_MAX_ATTRIB_STACK_DEPTH, &val);
	fprintf(stdout, "GL_MAX_ATTRIB_STACK_DEPTH:     %d\n", val);

	glGetIntegerv(GL_MAX_CLIP_PLANES, &val);
	fprintf(stdout, "GL_MAX_CLIP_PLANES:            %d\n", val);

	glGetIntegerv(GL_MAX_EVAL_ORDER, &val);
	fprintf(stdout, "GL_MAX_EVAL_ORDER:             %d\n", val);

	glGetIntegerv(GL_MAX_LIGHTS, &val);
	fprintf(stdout, "GL_MAX_LIGHTS:                 %d\n", val);

	glGetIntegerv(GL_MAX_LIST_NESTING, &val);
	fprintf(stdout, "GL_MAX_LIST_NESTING:           %d\n", val);

	glGetIntegerv(GL_MAX_MODELVIEW_STACK_DEPTH, &val);
	fprintf(stdout, "GL_MAX_MODELVIEW_STACK_DEPTH:  %d\n", val);

	glGetIntegerv(GL_MAX_NAME_STACK_DEPTH, &val);
	fprintf(stdout, "GL_MAX_NAME_STACK_DEPTH:       %d\n", val);

	glGetIntegerv(GL_MAX_PIXEL_MAP_TABLE, &val);
	fprintf(stdout, "GL_MAX_PIXEL_MAP_TABLE:        %d\n", val);

	glGetIntegerv(GL_MAX_PROJECTION_STACK_DEPTH, &val);
	fprintf(stdout, "GL_MAX_PROJECTION_STACK_DEPTH: %d\n", val);

	glGetIntegerv(GL_MAX_TEXTURE_SIZE, &val);
	fprintf(stdout, "GL_MAX_TEXTURE_SIZE:           %d\n", val);

	glGetIntegerv(GL_MAX_TEXTURE_STACK_DEPTH, &val);
	fprintf(stdout, "GL_MAX_TEXTURE_STACK_DEPTH:    %d\n", val);

	glGetIntegerv(GL_MAX_VIEWPORT_DIMS, dm);
	fprintf(stdout, "GL_MAX_VIEWPORT_DIMS:          %d %d\n", dm[0], dm[1]);

	fprintf(stdout, "----------------------------------------------------\n");

	glGetIntegerv(GL_SUBPIXEL_BITS, &val);
	fprintf(stdout, "GL_SUBPIXEL_BITS:              %d\n", val);

	glGetFloatv(GL_POINT_SIZE_RANGE, fval);
	fprintf(stdout, "GL_POINT_SIZE_RANGE:           %f %f\n", fval[0], fval[1]);

	glGetFloatv(GL_POINT_SIZE_GRANULARITY, fval);
	fprintf(stdout, "GL_POINT_GRANULARITY:          %f\n", fval[0]);

	glGetFloatv(GL_LINE_WIDTH_RANGE, fval);
	fprintf(stdout, "GL_LINE_WIDTH_RANGE:           %f %f\n", fval[0], fval[1]);

	glGetFloatv(GL_LINE_WIDTH_GRANULARITY, fval);
	fprintf(stdout, "GL_LINE_WIDTH_GRANULARITY:     %f\n", fval[0]);

	fprintf(stdout, "----------------------------------------------------\n");


#ifdef	GLU11
	glu_version = gluGetString(GLU_VERSION);
	glu_extentions = gluGetString(GLU_EXTENSIONS);
	glu_renderer = gluGetString(GL_RENDERER);

	fprintf(stdout, "GLU_VERSION:                   %s\n", glu_version);
	fprintf(stdout, "GLU_EXTENSIONS:                %s\n", glu_extentions);
	fprintf(stdout, "GL_RENDERER:                   %s\n", glu_renderer);

	fprintf(stdout, "----------------------------------------------------\n");
#endif

	fflush(stdout);
}
